#![allow(non_snake_case, non_upper_case_globals, non_camel_case_types)]

use core::ops::{BitOr};

use raw_pointer::*;
use volatile_register::*;
/* @file reg_pbist.h
*   @brief PBIST Register Layer Header File
*   @date 11-Dec-2018
*   @version 04.07.01
*   
*   This file contains:
*   - Definitions
*   - Types
*   .
*   which are relevant for the System driver.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com 
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/



/* PBIST Register Frame Definition */
/* @struct pbistBase
*   @brief PBIST Base Register Definition
*
*   This structure is used to access the PBIST module registers.
*/
/* @typedef pbistBASE_t
*   @brief PBIST Register Frame Type Definition
*
*   This type is used to access the PBIST Registers.
*/
#[repr(C)]
pub struct pbistBASE_t
{
    pub RAMT: RW<u32>,              /* 0x0160: RAM Configuration Register */
    pub DLR: RW<u32>,               /* 0x0164: Datalogger Register */
        rsvd0: RW<u32>,             /* 0x0168 */
    pub PCR: RW<u32>,               /*0x016C Program Control Register */ /*Author's Note: In original code, this was within a reserved block */
        rsvd1: [RW<u32>; 4],        /*0x0170 */ /*Author's Note: Please check my math so that this aligns with PACT */
    pub PACT: RW<u32>,              /* 0x0180: PBIST Activate Register */
    pub PBISTID: RW<u32>,           /* 0x0184: PBIST ID Register */
    pub OVER: RW<u32>,              /* 0x0188: Override Register */
        rsvd2: RW<u32>,             /* 0x018C */
    pub FSRF0: RO<u32>,             /* 0x0190: Fail Status Fail Register 0 */
    pub rsvd5: RW<u32>,             /* 0x0194 */
    pub FSRC0: RO<u32>,             /* 0x0198: Fail Status Count Register 0 */
    pub FSRC1: RO<u32>,             /* 0x019C: Fail Status Count Register 1 */
    pub FSRA0: RO<u32>,             /* 0x01A0: Fail Status Address 0 Register */
    pub FSRA1: RO<u32>,             /* 0x01A4: Fail Status Address 1 Register */
    pub FSRDL0: RO<u32>,            /* 0x01A8: Fail Status Data Register 0 */
        rsvd3: RW<u32>,             /* 0x01AC */
    pub FSRDL1: RO<u32>,            /* 0x01B0: Fail Status Data Register 1 */
        rsvd4: [RW<u32>; 3],        /* 0x01B4 */
    pub ROM: RW<u32>,               /* 0x01C0: ROM Mask Register */
    pub ALGO: RW<u32>,              /* 0x01C4: Algorithm Mask Register */
    pub RINFOL: RW<u32>,            /* 0x01C8: RAM Info Mask Lower Register */
    pub RINFOU: RW<u32>,            /* 0x01CC: RAM Info Mask Upper Register */
}


/* Author's Note: Documentation starts PBIST at 0xFFFF_E400, yet autogenerated code starts PBIST at 0xFFFF_E560
    This is because the first offset is at 0x0160. */
// #define pbistREG   ((pbistBASE_t *)0xFFFFE560U)
pub const pbistREG: Pointer<pbistBASE_t> = Pointer::<pbistBASE_t> {
    ptr: 0xFFFFE560u32 as *mut pbistBASE_t
};

pub enum pbistAlgo {
    TripleReadSlow      = 0x1,
    TripleReadFast      = 0x2,
    March13N_DP         = 0x4,
    March13N_SP         = 0x8,
    DOWN1a_DP           = 0x10,
    DOWN1a_SP           = 0x20,
    MapColumn_DP        = 0x40,
    MapColumn_SP        = 0x80,
    Precharge_DP        = 0x100,
    Precharge_SP        = 0x200,
    DTXN2a_DP           = 0x400,
    DTXN2a_SP           = 0x800,
    PMOSOpen_DP         = 0x1000,
    PMOSOpen_SP         = 0x2000,
    PPMOSOpenSlice1_DP  = 0x4000,
    PPMOSOpenSlice2_DP  = 0x8000,
    Flip10_DP           = 0x10000,
    Flip10_SP           = 0x20000,
    IDDQ_DP             = 0x40000,
    IDDQ_SP             = 0x80000,
    Retention_DP        = 0x100000,
    Retention_SP        = 0x200000,
    IDDQ2_DP            = 0x400000,
    IDDQ2_SP            = 0x800000,
    Retention2_DP       = 0x1000000,
    Retention2_SP       = 0x2000000,
    IDDQRowStripe_DP    = 0x4000000,
    IDDQRowStripe_SP    = 0x8000000,
    IDDQRowStripe2_DP   = 0x10000000,
    IDDQRowStripe2_SP   = 0x20000000,
}


impl BitOr for pbistAlgo {
    type Output = u32;
    
    fn bitor(self, rhs: Self) -> Self::Output {
        self as Self::Output | rhs as Self::Output
    }
}

impl pbistAlgo {
    pub fn value(self) -> u32 {
        self as u32
    }
}
